/**
 * All of the tumblers.
 */
function LockPickingTumblers(id, key, master, tumblersActive) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var amountOfTumblers = 5;

    var image = new LockPickingPreloadingTumbler();

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Creates the tumblers.
     */
    function populateTumblers() {
        for (var i = 0; i < tumblersActive; i++) {
            that.tumblers.push(new LockPickingTumbler(id, key, master, i, true));
        }
        for (var i = tumblersActive; i < amountOfTumblers; i++) {
            that.tumblers.push(new LockPickingTumbler(id, key, master, i, false));
        }
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.tumblers = [];


    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML.
     */
    this.build = function () {
        var output = "";
        for (var i = 0; i < that.tumblers.length; i++) {
            output += that.tumblers[i].build();
        }
        return output;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {
        for (var i = 0; i < that.tumblers.length; i++) {
            that.tumblers[i].registerListeners();
        }
    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return image.preload();
    };

    /**
     * Causes the specified tumbler to go up.
     * @param {int} which Which tumbler needs to go up.
     * @param {int} time How quickly it should go up, in milliseconds.
     * @param {int} grace Distributed around the peak of the tumbler's trajectory, how long in milliseconds the user has to click it to succeed.
     */
    this.up = function (which, time, grace) {
        that.tumblers[which].up(time, grace);
    };

    /**
     * Returns whether or not the specified tumbler is mid-animation.
     * @param {int} which Which tumbler.
     * @return {boolean} Whether or not the specified tumbler is mid-animation.
     */
    this.inAnimation = function (which) {
        return that.tumblers[which].inAnimation;
    };

    this.reset = function () {
        for (var i = 0; i < tumblersActive; i++) {
            that.tumblers[i].reset();
        }
    };

    populateTumblers();
}
