/**
 * Controller for the Caravan Confinement scene.
 * @param {string} sceneId The id of the scene.
 */
function RiversideMarshController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = false;
    this.nextSceneName = "HamletAuction";
    this.nextFolderName = "Enslavement";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ChangeController(id, "arrival", function () {
        global.kobold.status.mental.increase(10, "Finding a landmark");
        global.kobold.status.stamina.decrease(5, "Rough terrain traversal");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Landmark", "Sanity", +5),
            new Change("A way out?", "Sanity", +5),
            new Change("Traversing rough terrain", "Stamina", -5)
        ]);
    });

    this.downstream = new ChangeController(id, "downstream", function () {
        global.kobold.status.mental.increase(5, "Going home");
        global.kobold.status.stamina.decrease(5, "Walking on tired feet");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Going home", "Sanity", +5),
            new Change("More hiking", "Stamina", -5)
        ]);
    });

    this.preContinue = new ContinueController(id, "preContinue");

    this.riverAmbience = new AudioController(id, "res/audio/effects/river.mp3", 100);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}
