/**
 * This class acts as a dedicated controller for the watch section of the bandit part of the Forest scene.
 * @param {string} sceneId The id of the scene.
 */
function ForestBanditWatchController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;

    var watchId = "banditWatchChoice";
    var watchSharedId = "banditWatchShared";

    var keepWatchingId = "banditKeepWatchingChoice";

    var masturbateId = "banditMasturbateChoice";
    var masturbateBraId = "banditMasturbateBra";
    var masturbatePantsId = "banditMasturbatePants";
    var masturbateUnderwearId = "banditMasturbateUnderwear";
    var masturbateShirtId = "banditMasturbateShirt";
    var masturbateBoobsId = "banditMasturbateBoobs";
    var masturbateCuntId = "banditMasturbateCunt";
    var masturbateCuntVirginId = "banditMasturbateCuntVirgin";
    var masturbateCockId = "banditMasturbateCock";
    var masturbateGenderId = "banditMasturbateGender";

    var masturbateIndulgeId = "banditMasturbateIndulge";
    var masturbateIndulgeSharedId = "banditMasturbateIndulgeShared";
    var masturbateIndulgeChangeId = "banditMasturbateIndulgeChange";
    var masturbateIndulgeChangeTogetherId = "banditMasturbateIndulgeChangeTogether";

    var stealId = "banditStealChoice";
    var stealSharedId = "banditStealShared";
    var stealItemsId = "banditStealItems";

    var helpId = "banditHelpChoice";
    var helpSharedId = "banditHelpShared";
    var helpSource = "banditHelpSource";
    var helpStatusId = "banditHelpStatus";

    var scavengeId = "banditScavengeChoice";
    var scavengeSharedId = "banditScavengeShared";
    var scavengeSource = "banditScavengeSource";

    var scavengeContinueId = "banditScavengeContinueChoice";
    var scavengeContinueUnderwearId = "banditScavengeContinueUndies";
    var scavengeContinuePantsId = "banditScavengeContinuePants";
    var scavengeContinueChangeId = "banditScavengeContinueChange";

    var sloppySecondsId = "banditSloppySecondsChoice";
    var sloppySecondsSharedId = "banditSloppySecondsShared";
    var sloppySecondsStatusId = "banditSloppySecondsStatus";
    var sloppySecondsBraId = "banditSloppySecondsBra";
    var sloppySecondsPantsId = "banditSloppySecondsPants";
    var sloppySecondsUnderwearId = "banditSloppySecondsUnderwear";
    var sloppySecondsShirtId = "banditSloppySecondsShirt";
    var sloppySecondsBoobsId = "banditSloppySecondsBoobs";
    var sloppySecondsCuntId = "banditSloppySecondsCunt";
    var sloppySecondsCuntVirginId = "banditSloppySecondsCuntVirgin";
    var sloppySecondsCockId = "banditSloppySecondsCock";
    var sloppySecondsCockVirginId = "banditSloppySecondsCockVirgin";
    var sloppySecondsGenderId = "banditSloppySecondsGender";


    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Makes the watch choice.
     * @param {ForestBanditWatchChoiceEnum} choice The choice.
     */
    this.makeWatchChoice = function (choice) {
        var history = global.kobold.history.get(id);
        history[watchId] = choice;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the watch choice from history and returns it.
     * May return undefined if the watch choice has not yet been set.
     * @returns {ForestBanditWatchChoiceEnum} The choice.
     */
    this.getWatchChoice = function () {
        var history = global.kobold.history.get(id);
        return history[watchId];
    };

    /**
     * Returns true if the watch choice has been made.
     */
    this.hasMadeWatchChoice = function () {
        return global.kobold.history.has(id, watchId);
    };

    /**
     * Makes the watch shared changes.
     */
    this.watchShared = function () {
        global.kobold.history.doIfNotSet(id, watchSharedId, true, function () {
            global.kobold.history.shared.tenPawGang.relation = TenPawGangEnum.DEEPLY_OBSERVED;
            global.kobold.history.shared.tenPawGang.footsie = TenPawGangFootsieEnum.OBSERVED;
        });
    };


    /**
     * Makes the keep watching choice.
     * @param {ForestBanditKeepWatchingChoiceEnum} choice The choice.
     */
    this.makeKeepWatchingChoice = function (choice) {
        var history = global.kobold.history.get(id);
        history[keepWatchingId] = choice;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the keep watching choice from history and returns it.
     * May return undefined if the keep watching choice has not yet been set.
     * @returns {ForestBanditKeepWatchingChoiceEnum} The choice.
     */
    this.getKeepWatchingChoice = function () {
        var history = global.kobold.history.get(id);
        return history[keepWatchingId];
    };

    /**
     * Returns true if the keep watching choice has been made.
     */
    this.hasMadeKeepWatchingChoice = function () {
        return global.kobold.history.has(id, keepWatchingId);
    };


    /**
     * Makes the masturbate choice.
     * @param {ForestBanditMasturbateChoiceEnum} choice The choice.
     */
    this.makeMasturbateChoice = function (choice) {
        var history = global.kobold.history.get(id);
        history[masturbateId] = choice;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the masturbate choice from history and returns it.
     * May return undefined if the masturbate choice has not yet been set.
     * @returns {ForestBanditMasturbateChoiceEnum} The choice.
     */
    this.getMasturbateChoice = function () {
        var history = global.kobold.history.get(id);
        return history[masturbateId];
    };

    /**
     * Returns true if the masturbate choice has been made.
     */
    this.hasMadeMasturbateChoice = function () {
        return global.kobold.history.has(id, masturbateId);
    };

    /**
     * Stores (if required) and retrieves the kobold's pants at masturbate-time.
     * @returns {Gear} The pants.
     */
    this.masturbatePants = function () {
        if (!global.kobold.history.has(id, masturbatePantsId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.PANTS)) {
                history[masturbatePantsId] = global.kobold.inventory.equipment.pants;
            } else {
                history[masturbatePantsId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[masturbatePantsId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at masturbate-time.
     * @returns {Gear} The underwear.
     */
    this.masturbateUnderwear = function () {
        if (!global.kobold.history.has(id, masturbateUnderwearId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.UNDERWEAR)) {
                history[masturbateUnderwearId] = global.kobold.inventory.equipment.underwear;
            } else {
                history[masturbateUnderwearId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[masturbateUnderwearId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at masturbate-time.
     * @returns {Gear} The shirt.
     */
    this.masturbateShirt = function () {
        if (!global.kobold.history.has(id, masturbateShirtId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.SHIRT)) {
                history[masturbateShirtId] = global.kobold.inventory.equipment.shirt;
            } else {
                history[masturbateShirtId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[masturbateShirtId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at masturbate-time.
     * @returns {Gear} The bra.
     */
    this.masturbateBra = function () {
        if (!global.kobold.history.has(id, masturbateBraId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.BRA)) {
                history[masturbateBraId] = global.kobold.inventory.equipment.bra;
            } else {
                history[masturbateBraId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[masturbateBraId]);
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has boobs at masturbate-time.
     * @returns {boolean} Whether or not the kobold has boobs at masturbate-time.
     */
    this.masturbateBoobs = function () {
        if (!global.kobold.history.has(id, masturbateBoobsId)) {
            var history = global.kobold.history.get(id);
            history[masturbateBoobsId] = global.kobold.body.hasBreasts();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[masturbateBoobsId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has a cunt at masturbate-time.
     * @returns {boolean} Whether or not the kobold has a cunt at masturbate-time.
     */
    this.masturbateCunt = function () {
        if (!global.kobold.history.has(id, masturbateCuntId)) {
            var history = global.kobold.history.get(id);
            history[masturbateCuntId] = global.kobold.body.hasCunt();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[masturbateCuntId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold's cunt is virginal at masturbate-time.
     * @returns {boolean} Whether or not the kobold's cunt is virginal at masturbate-time.
     */
    this.masturbateCuntVirgin = function () {
        if (!global.kobold.history.has(id, masturbateCuntVirginId)) {
            var history = global.kobold.history.get(id);
            history[masturbateCuntVirginId] = global.kobold.body.vaginalVirgin;
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[masturbateCuntVirginId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has a dick at masturbate-time.
     * @returns {boolean} Whether or not the kobold has a dick at masturbate-time.
     */
    this.masturbateCock = function () {
        if (!global.kobold.history.has(id, masturbateCockId)) {
            var history = global.kobold.history.get(id);
            history[masturbateCockId] = global.kobold.body.hasDick();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[masturbateCockId];
    };
    /**
     * Stores (if required) and retrieves the kobold's base gender at masturbate-time.
     * @returns {GenderEnum} The kobold's base gender at masturbate-time.
     */
    this.masturbateBaseGender = function () {
        if (!global.kobold.history.has(id, masturbateGenderId)) {
            var history = global.kobold.history.get(id);
            history[masturbateGenderId] = global.kobold.body.getBaseGender();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[masturbateGenderId];
    };


    /**
     * Makes the masturbate indulging choice.
     * @param {ForestBanditMasturbateIndulgeChoiceEnum} choice The choice.
     */
    this.makeMasturbateIndulgeChoice = function (choice) {
        var history = global.kobold.history.get(id);
        history[masturbateIndulgeId] = choice;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the masturbate indulging choice from history and returns it.
     * May return undefined if the masturbate indulge choice has not yet been set.
     * @returns {ForestBanditMasturbateIndulgeChoiceEnum} The choice.
     */
    this.getMasturbateIndulgeChoice = function () {
        var history = global.kobold.history.get(id);
        return history[masturbateIndulgeId];
    };

    /**
     * Returns true if the masturbate indulging choice has been made.
     */
    this.hasMadeMasturbateIndulgeChoice = function () {
        return global.kobold.history.has(id, masturbateIndulgeId);
    };

    /**
     * Makes the masturbate indulge shared changes.
     */
    this.masturbateIndulgeShared = function () {
        global.kobold.history.doIfNotSet(id, masturbateIndulgeSharedId, true, function () {
            global.kobold.history.shared.tenPawGang.relation = TenPawGangEnum.DEEPLY_OBSERVED;
            if (that.getMasturbateChoice() === ForestBanditMasturbateChoiceEnum.INDULGE) {
                global.kobold.history.shared.tenPawGang.footsie = TenPawGangFootsieEnum.MASTURBATION_INDULGED;
            } else {
                global.kobold.history.shared.tenPawGang.footsie = TenPawGangFootsieEnum.MASTURBATION_DECLINED;
            }
        });
    };

    /**
     * Alters the kobold's stats if required.
     * @returns {string} HTML describing the change.
     */
    this.masturbateIndulgeTogetherChange = function () {
        if (!global.kobold.history.has(id, masturbateIndulgeChangeTogetherId)) {
            global.kobold.status.mental.increase(5, "Made a friend");
            global.kobold.status.exertion.increase(20, "Masturbation");
            var history = global.kobold.history.get(id);
            history[masturbateIndulgeChangeTogetherId] = true;
            global.kobold.history.set(id, history);
        }
        return global.ui.change.buildNotification([
            new Change("Made a friend", "Sanity", +5),
            new Change("Masturbation", "Sexual exhaustion", +20, true)
        ]);
    };

    /**
     * Alters the kobold's stats if required.
     * @returns {string} HTML describing the change.
     */
    this.masturbateIndulgeChange = function () {
        if (!global.kobold.history.has(id, masturbateIndulgeChangeId)) {
            global.kobold.status.exertion.increase(20, "Masturbation");
            var history = global.kobold.history.get(id);
            history[masturbateIndulgeChangeId] = true;
            global.kobold.history.set(id, history);
        }
        return global.ui.change.buildNotification([
            new Change("Masturbation", "Sexual exhaustion", +20, true)
        ]);
    };


    /**
     * Announces the steal continue button has been pressed.
     */
    this.stealContinue = function () {
        var history = global.kobold.history.get(id);
        history[stealId] = true;
        global.kobold.history.set(id, history);
    };

    /**
     * Returns true if the steal continue button has been pressed.
     */
    this.stealHasContinued = function () {
        return global.kobold.history.has(id, stealId);
    };
    
    /**
     * Makes the steal shared changes.
     */
    this.stealShared = function () {
        global.kobold.history.doIfNotSet(id, stealSharedId, true, function () {
            global.kobold.history.shared.dragonessPrincess.relation = DragonessPrincessEnum.UNHELPED;
            global.kobold.history.shared.tenPawGang.relation = TenPawGangEnum.STOLEN_FROM;
        });
    };

    /**
     * Gives the kobold items if required.
     * @returns {string} HTML describing the change.
     */
    this.stealItems = function () {
        if (!global.kobold.history.has(id, stealItemsId)) {
            global.kobold.inventory.coins += 30;
            global.kobold.inventory.bag.addMisc(new BanditKey());
            var history = global.kobold.history.get(id);
            history[stealItemsId] = true;
            global.kobold.history.set(id, history);
        }
        return global.ui.change.buildNotification([
            new Change("Loot", "Gold", +30),
            new Change("Loot", "Bandit key", +1)
        ]);
    };


    /**
     * Sets the help section's source.
     * @param {ForestBanditHelpSourceEnum} choice The choice.
     */
    this.setHelpSource = function (source) {
        var history = global.kobold.history.get(id);
        history[helpSource] = source;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the source of the help section from history and returns it.
     * May return undefined if the source has not yet been set.
     * @returns {ForestBanditHelpSourceEnum} The source.
     */
    this.getHelpSource = function () {
        var history = global.kobold.history.get(id);
        return history[helpSource];
    };

    /**
     * Returns true if the help section has a source.
     */
    this.hasHelpSource = function () {
        return global.kobold.history.has(id, helpSource);
    };
    
    /**
     * Makes the help shared changes.
     */
    this.helpShared = function () {
        global.kobold.history.doIfNotSet(id, helpSharedId, true, function () {
            global.kobold.history.shared.dragonessPrincess.relation = DragonessPrincessEnum.HELPED;
        });
    };

    /**
     * Alters the kobold's stats if required.
     * @returns {string} HTML describing the change.
     */
    this.helpStatus = function () {
        if (!global.kobold.history.has(id, helpStatusId)) {
            global.kobold.status.stamina.decrease(5, "Helping the dragoness");
            var history = global.kobold.history.get(id);
            history[helpStatusId] = true;
            global.kobold.history.set(id, history);
        }
        return global.ui.change.buildNotification([
            new Change("Did your best", "Sanity", +5),
            new Change("Still feel bad", "Sanity", -5),
            new Change("Heavy lifting", "Stamina", -5)
        ]);
    };

    /**
     * Announces the help continue button has been pressed.
     */
    this.helpContinue = function () {
        var history = global.kobold.history.get(id);
        history[helpId] = true;
        global.kobold.history.set(id, history);
    };

    /**
     * Returns true if the help continue button has been pressed.
     */
    this.helpHasContinued = function () {
        return global.kobold.history.has(id, helpId);
    };


    /**
     * Sets the scavenge section's source.
     * @param {ForestBanditScavengeSourceEnum} source The source.
     */
    this.setScavengeSource = function (source) {
        var history = global.kobold.history.get(id);
        history[scavengeSource] = source;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the source of the scavenge section from history and returns it.
     * May return undefined if the source has not yet been set.
     * @returns {ForestBanditScavengeSourceEnum} The source.
     */
    this.getScavengeSource = function () {
        var history = global.kobold.history.get(id);
        return history[scavengeSource];
    };

    /**
     * Returns true if the scavenge section has a source.
     */
    this.hasScavengeSource = function () {
        return global.kobold.history.has(id, scavengeSource);
    };

    /**
     * Makes the scavenge choice.
     * @param {ForestBanditScavengeChoiceEnum} choice The choice.
     */
    this.makeScavengeChoice = function (choice) {
        var history = global.kobold.history.get(id);
        history[scavengeId] = choice;
        global.kobold.history.set(id, history);
    };

    /**
     * Fetches the scavenge choice from history and returns it.
     * May return undefined if the scavenge choice has not yet been set.
     * @returns {ForestBanditScavengeChoiceEnum} The choice.
     */
    this.getScavengeChoice = function () {
        var history = global.kobold.history.get(id);
        return history[scavengeId];
    };

    /**
     * Returns true if the scavenge choice has been made.
     */
    this.hasMadeScavengeChoice = function () {
        return global.kobold.history.has(id, scavengeId);
    };
    
    /**
     * Makes the scavenge shared changes.
     */
    this.scavengeShared = function () {
        global.kobold.history.doIfNotSet(id, scavengeSharedId, true, function () {
            global.kobold.history.shared.dragonessPrincess.relation = DragonessPrincessEnum.UNHELPED;
        });
    };


    /**
     * Announces the scavenge continue button has been pressed.
     */
    this.scavengeContinue = function () {
        var history = global.kobold.history.get(id);
        history[scavengeContinueId] = true;
        global.kobold.history.set(id, history);
    };

    /**
     * Returns true if the scavenge continue button has been pressed.
     */
    this.scavengeHasContinued = function () {
        return global.kobold.history.has(id, scavengeContinueId);
    };

    /**
     * Stores (if required) and retrieves the kobold's pants at the end of scavenging.
     * @returns {Gear} The pants.
     */
    this.scavengeContinuePants = function () {
        if (!global.kobold.history.has(id, scavengeContinuePantsId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.PANTS)) {
                history[scavengeContinuePantsId] = global.kobold.inventory.equipment.pants;
            } else {
                history[scavengeContinuePantsId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[scavengeContinuePantsId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at the end of scavenging.
     * @returns {Gear} The underwear.
     */
    this.scavengeContinueUnderwear = function () {
        if (!global.kobold.history.has(id, scavengeContinueUnderwearId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.UNDERWEAR)) {
                history[scavengeContinueUnderwearId] = global.kobold.inventory.equipment.underwear;
            } else {
                history[scavengeContinueUnderwearId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[scavengeContinueUnderwearId]);
    };

    /**
     * Changes the kobold's underwear to panties if not done yet.
     */
    this.scavengeContinueChange = function () {
        if (!global.kobold.history.has(id, scavengeContinueChangeId)) {
            var panties = new SilkPanties();
            panties.stain("Cum and Mud");
            global.kobold.inventory.equipment.wear(panties);
            var history = global.kobold.history.get(id);
            history[scavengeContinueChangeId] = true;
            global.kobold.history.set(id, history);
        }
    };



    /**
     * Signals the continue button of the sloppy seconds scene has been pressed.
     */
    this.sloppySecondsContinue = function (choice) {
        var history = global.kobold.history.get(id);
        history[sloppySecondsId] = true;
        global.kobold.history.set(id, history);
    };

    /**
     * Returns true if the sloppy seconds continue button has been pressed.
     */
    this.sloppySecondsHasContinued = function () {
        return global.kobold.history.has(id, sloppySecondsId);
    };
    
    /**
     * Makes the sloppy seconds shared changes.
     */
    this.sloppySecondsShared = function () {
        global.kobold.history.doIfNotSet(id, sloppySecondsSharedId, true, function () {
            global.kobold.history.shared.dragonessPrincess.relation = DragonessPrincessEnum.SLOPPY_SECONDS;
        });
    };

    /**
     * Stores (if required) and retrieves the kobold's pants at sloppy seconds-time.
     * @returns {Gear} The pants.
     */
    this.sloppySecondsPants = function () {
        if (!global.kobold.history.has(id, sloppySecondsPantsId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.PANTS)) {
                history[sloppySecondsPantsId] = global.kobold.inventory.equipment.pants;
            } else {
                history[sloppySecondsPantsId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[sloppySecondsPantsId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at sloppy seconds-time.
     * @returns {Gear} The underwear.
     */
    this.sloppySecondsUnderwear = function () {
        if (!global.kobold.history.has(id, sloppySecondsUnderwearId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.UNDERWEAR)) {
                history[sloppySecondsUnderwearId] = global.kobold.inventory.equipment.underwear;
            } else {
                history[sloppySecondsUnderwearId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[sloppySecondsUnderwearId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at sloppy seconds-time.
     * @returns {Gear} The shirt.
     */
    this.sloppySecondsShirt = function () {
        if (!global.kobold.history.has(id, sloppySecondsShirtId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.SHIRT)) {
                history[sloppySecondsShirtId] = global.kobold.inventory.equipment.shirt;
            } else {
                history[sloppySecondsShirtId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[sloppySecondsShirtId]);
    };

    /**
     * Stores (if required) and retrieves the kobold's underwear at sloppy seconds-time.
     * @returns {Gear} The bra.
     */
    this.sloppySecondsBra = function () {
        if (!global.kobold.history.has(id, sloppySecondsBraId)) {
            var history = global.kobold.history.get(id);
            if (global.kobold.inventory.equipment.isWearing(SlotEnum.BRA)) {
                history[sloppySecondsBraId] = global.kobold.inventory.equipment.bra;
            } else {
                history[sloppySecondsBraId] = null;
            }
            global.kobold.history.set(id, history);
        }
        return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.get(id)[sloppySecondsBraId]);
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has boobs at sloppy seconds-time.
     * @returns {boolean} Whether or not the kobold has boobs at sloppy seconds-time.
     */
    this.sloppySecondsBoobs = function () {
        if (!global.kobold.history.has(id, sloppySecondsBoobsId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsBoobsId] = global.kobold.body.hasBreasts();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsBoobsId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has a cunt at sloppy seconds-time.
     * @returns {boolean} Whether or not the kobold has a cunt at sloppy seconds-time.
     */
    this.sloppySecondsCunt = function () {
        if (!global.kobold.history.has(id, sloppySecondsCuntId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsCuntId] = global.kobold.body.hasCunt();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsCuntId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold's cunt is virginal at sloppy seconds-time.
     * @returns {boolean} Whether or not the kobold's cunt is virginal at sloppy seconds-time.
     */
    this.sloppySecondsCuntVirgin = function () {
        if (!global.kobold.history.has(id, sloppySecondsCuntVirginId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsCuntVirginId] = global.kobold.body.vaginalVirgin;
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsCuntVirginId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold has a dick at sloppy seconds-time.
     * @returns {boolean} Whether or not the kobold has a dick at sloppy seconds-time.
     */
    this.sloppySecondsCock = function () {
        if (!global.kobold.history.has(id, sloppySecondsCockId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsCockId] = global.kobold.body.hasDick();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsCockId];
    };

    /**
     * Stores (if required) and retrieves whether or not the kobold's cock (giving) is virginal at sloppy seconds-time.
     * @returns {boolean} Whether or not the kobold's cock is virginal at sloppy seconds-time.
     */
    this.sloppySecondsCockVirgin = function () {
        if (!global.kobold.history.has(id, sloppySecondsCockVirginId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsCockVirginId] = global.kobold.body.dickVirgin;
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsCockVirginId];
    };

    /**
     * Stores (if required) and retrieves the kobold's base gender at sloppy seconds-time.
     * @returns {GenderEnum} The kobold's base gender at sloppy seconds-time.
     */
    this.sloppySecondsBaseGender = function () {
        if (!global.kobold.history.has(id, sloppySecondsGenderId)) {
            var history = global.kobold.history.get(id);
            history[sloppySecondsGenderId] = global.kobold.body.getBaseGender();
            global.kobold.history.set(id, history);
        }
        return global.kobold.history.get(id)[sloppySecondsGenderId];
    };

    /**
     * Alters the kobold's stats if required.
     * @returns {string} HTML describing the change.
     */
    this.sloppySecondsStatus = function () {
        if (that.sloppySecondsCock()) {
            if (!global.kobold.history.has(id, sloppySecondsStatusId)) {
                global.kobold.status.exertion.increase(25, "Dragoness sloppy seconds");
                global.kobold.status.stamina.decrease(15, "Fucking a dragoness");
                global.kobold.body.dickVirgin = false;
                var history = global.kobold.history.get(id);
                history[sloppySecondsStatusId] = true;
                global.kobold.history.set(id, history);
            }
            return global.ui.change.buildNotification([
                new Change("Sloppy seconds", "Sexual exhaustion", +25, true),
                new Change("Intense fucking", "Stamina", -15)
            ]);
        } else {
            if (!global.kobold.history.has(id, sloppySecondsStatusId)) {
                global.kobold.status.exertion.increase(25, "Bisexual dragoness cleaning");
                var history = global.kobold.history.get(id);
                history[sloppySecondsStatusId] = true;
                global.kobold.history.set(id, history);
            }
            return global.ui.change.buildNotification([
                new Change("Sloppy seconds", "Sexual exhaustion", +25, true)
            ]);
        }


    };
}
