/**
 * Serve section of Varanar, Noon Three.
 * @param {NoonThreeStoreController} controller The Varanar, Noon Three controller.
 */
function NoonThreeStoreProposal(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.arrival;
    var subController = ctrl.proposal;
    var changeController = ctrl.proposal;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new NoonThreeStoreDecline(ctrl);
    var secondNext = new NoonThreeStoreHandjobAccept(ctrl);
    var thirdNext = new NoonThreeStoreHandjobMoreMoney(ctrl);

    var firstChoice = ctrl.NoonThreeStoreMoneyChoice.DECLINE;
    var secondChoice = ctrl.NoonThreeStoreMoneyChoice.ACCEPT;
    var thirdChoice = ctrl.NoonThreeStoreMoneyChoice.MOREMONEY;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var sekiMet = global.kobold.history.shared.seki.knowsDying;
        var naked = ctrl.misc.importantNude();
        var crossdressing = ctrl.misc.crossdressing();
        var oppositeGender = ctrl.misc.baseGender() === GenderEnum.MALE ? `girly` : `boyish`;
        oppositeGender = ctrl.misc.gender() === GenderEnum.CUNTBOY ? `boyish` : oppositeGender;
        var toReturn = `[p]
                            You've never really [i]been[/i] in a [i]real[/i] store before.
                            Your few visits to your ${sekiMet ? `` : `fatherly friend and fence`} Seki's ${sekiMet ? `` : `alchemical`} workshop,
                            to pawn off your meagre thieving pickings, don't count.
                            It's kind of [b]exciting[/b] to finally get to see the insides of a Varanarian shop.
                            Although you don't quite know what to expect, you push open the door, and step inside.
                        [/p]
                        [p]
                            You enter a rather large room, filled to the brim with a wide variety of goods.
                            Various tables, racks, display cases and opened chests showcase the store's wares.
                            At the opposite end of the room, behind a wide counter, there sits a grey-scaled anthromorphic dragon.
                            At least you [i]think[/i] he's sitting, unless he's as tiny as you are somehow.
                            You presume that's [i]Rolande[/i].
                            Besides him, the shop appears to be empty.
                        [/p]
                        [p]
                            At first, the dragon doesn't even [b]notice[/b] you.
                            He's leaning back on his stool, his eyes closed,
                            one of his arms disappearing underneath the counter,
                            slightly moving up and down in a slow, rhythmical fashion.
                            You believe you've walked in on a shopkeeper jerking off on the job.
                        [/p]
                        [p]
                            Starting to feel [b]very[/b] awkward, you consider turning around and [b]leaving[/b] before the masturbating man notices you.
                            Then again, you're not at fault here.
                            He's running a store, which is currently open for business.
                            He shouldn't be rubbing one out without at least locking the door first!
                            If anything, [b]you[/b] should feel outraged that he has the [b]audacity[/b] to openly stroke himself in the middle of the day!
                            But, being a kobold, you don't [i]get[/i] to complain about things like these.
                            You should be happy you're allowed to enter stores in the first place.
                        [/p]
                        [p]
                            In order to grab the merchant's attention, you loudly slam the door shut behind you.
                            The dragon's eyes shoot open, he lets out a surprised sigh, and his jerking hand shoots upwards from his lap onto the counter.
                            "[color=yellow]Ah, a customer![/color]" he greets you warmly, wiping his palm on a nearby rag.
                            Only [b]now[/b] actually [i]looking[/i] at you, the initial enthousiasm fades from his voice.
                            "[color=yellow]Oh.
                            A [b]kobold[/b].
                            What do [i]you[/i] want?[/color]"
                        [/p]
                        [p]
                            Walking up to the counter, you explain that you're here to [i]buy[/i] things.
                            He [i]is[/i] running a [b]store[/b], right?
                            "[color=yellow]I don't think someone of [i]your[/i] kind has the [i]means[/i] to purchase wares from my [i]establishment[/i].[/color]"
                            The shopkeep eyes you up and down.
                            "[color=yellow]${naked ? `Your lack of clothing isn't` : `Those rags you call [i]clothing[/i] aren't`} helping your case.[/color]"
                            ${crossdressing ? `And what's that ${oppositeGender} thing you're wearing?` : ``}
                        [/p]
                        [p]
                            You struggle to form a counterargument while the dragon continues to eye you up and down.
                            He lustily licks his lips, one of his hands slinking underneath the counter once more.
                            "[color=yellow]But now that you [i]are[/i] here, I might as well make you an [i]offer[/i].[/color]"
                            His arm begins to move up and down once more, the man clearly jerking off right in front of you.
                            "[color=yellow]As you might have noticed, I have a little [i]problem[/i].
                            Help me out with it, and I'll make it worth your while.[/color]"
                        [/p]
                        [p]
                            His intentions revealed, the draconian merchant no longer attempts to hide his masturbation,
                            his hand audibly sliding up and down his length.
                            "[color=yellow]So, what'll it be, kobold?
                            Just a [i]hand[/i], that's all I ask for.
                            Thirty coins, enough to buy at least [b]one[/b] item from my store.
                            Plus I'll throw in a little [i]discount[/i].
                            Far more than a little [b]whore[/b] like you is worth, don't you think?[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`Hell no. You just want to browse his wares. He can continue doing whatever it is he was doing afterwards.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Accept</button>`;

        var tooltip = global.parser.parse(`You [i]could[/i] use the money. What's the worst that could happen?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var failedCheck = ctrl.misc.intelligence() < 6 && ctrl.misc.charisma() < 6;
        var disabled = subController.has() || failedCheck ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>More money</button>`;

        var tooltip = global.parser.parse(`It's not enough. Maybe if the dragon adds another twenty coins, you'll consider [i]touching[/i] him.`);
        if (failedCheck) {
            tooltip = global.parser.parse(`You're not smart or charismatic enough to ask for more money.`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 240px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.applyTheme("hamlet_barn");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}
